unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShellAPI, ComCtrls, DateUtils;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button2: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    SendCommand: String;
    AName,AProcess: TStringList;
    GProcessID: Longint;
    Buffer: array[0..MAX_PATH] of Char;    // holds the system directory
  public
    { Public declarations }
  end;

function EnumerateWindows(hWnd: HWND; lParam: LPARAM): BOOL; stdcall; export;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function EnumerateWindows(hWnd: HWND; lParam: LPARAM): BOOL;
var
   WindowText: array[0..255] of char;
begin
   {get the text displayed in the window}
   GetWindowText(hWnd, WindowText, 255);

   {indicate if the window does not have any text}
   //if (WindowText='') then WindowText:='[No Window Text]';

   {add an item to the treeview object for a top level window}
   //Form1.Memo1.Lines.Add(WindowText+' ---> '+IntToStr(hWnd));
   Form1.AName.Add(WindowText);
   Form1.AProcess.Add(IntToStr(hWnd));
   //if (WindowText <> '') and (WindowText <> 'Default IME') then  Form1.AProcess.Add(IntToStr(hWnd));
   {continue enumeration of top level windows}
   Result:=TRUE;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: Integer;
  B: Boolean;
  Name: String;
  H1,H2,H3: Hwnd;
  ProcessId: LongInt;   // holds the process identifier
  SI: TStartUpInfo;   // holds startup information
  PI: TProcessInformation;   // holds process information
  TheWindowText: array[0..255] of char;
  VerInfo: TOSVersionInfo;
  WindowText: array[0..255] of char;
begin
  // get windows version
  VerInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  GetVersionEx(VerInfo);
  {initialize the startup information}
  FillChar(SI, SizeOf(TStartupInfo), 0);
  with SI do
  begin
    cb := SizeOf(TStartupInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := SW_SHOW;
  end;
  // Ъ`N CreateProcess |]  windows gk|ҤP  ثeO win2000
  if VerInfo.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS then
     B := CreateProcess(Nil,Buffer,Nil, Nil, False, NORMAL_PRIORITY_CLASS, Nil, Nil, SI, PI)
  else
     B := CreateProcess(Buffer,Nil,Nil, Nil, False, NORMAL_PRIORITY_CLASS, Nil, Nil, SI, PI);
  WaitForInputIdle(PI.hProcess, 1000);
  H2 := Panel1.Handle;
  B := False;
  AName := TStringlist.Create;
  AProcess := TStringList.Create;
  try
    while not B do begin
    EnumWindows(@EnumerateWindows,0);
    for I := 0 to AProcess.Count-1 do begin
        H1 := HWND(StrToInt(AProcess.Strings[I]));
        Name := AName.Strings[I];
        GetWindowThreadProcessId(H1,@ProcessId);
        if ProcessId = PI.dwProcessId then begin
           GProcessID := ProcessID;
           B := True;
           Break;
        end;
    end;
    end;
    if B then begin
       //GetClassName(H1,WindowText,255);
       //Memo2.Lines.Add(WindowText);
       //H1 := FindWindow(WindowText, Nil);
       Windows.SetParent(H1,H2);
      // ShowWindow(H1,SW_SHOWNORMAL); // pG StartupInfo  wShowWindow := SW_HIDE ɴNnϥ
       Button3Click(Nil);
    end;
  finally
    AName.Free;
    AProcess.Free;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  TileWindows(Panel1.Handle,MDITILE_VERTICAL,nil,0,nil);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FillChar(Buffer, SizeOf(Buffer), Ord(' '));
  FindExecutable(PChar('NOTEPAD.EXE'), nil, @Buffer);
  Button2Click(Nil);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  FillChar(Buffer, SizeOf(Buffer), Ord(' '));
  FindExecutable(PChar('CALC.EXE'), nil, @Buffer);
  Button2Click(Nil);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  FillChar(Buffer, SizeOf(Buffer), Ord(' '));
  FindExecutable(PChar('REGEDIT.EXE'), nil, @Buffer);
  Button2Click(Nil);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  FillChar(Buffer, SizeOf(Buffer), Ord(' '));
  FindExecutable(PChar('POLEDIT.EXE'), nil, @Buffer);
  Button2Click(Nil);
end;

end.
